- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# OsiSolverInterface Class Reference

Solver Interface Abstract Base Class. More...

`#include <OsiSolverInterface.hpp>`

Inheritance diagram for OsiSolverInterface:

[legend]
Collaboration diagram for OsiSolverInterface:

[legend]
List of all members.

## Public Types
typedef std::vector< std::string > | OsiNameVec
| Data type for name vectors.
## Public Member Functions
Solve methods
virtual void | initialSolve ()=0
| Solve initial LP relaxation.
virtual void | resolve ()=0
| Resolve an LP relaxation after problem modification.
virtual void | branchAndBound ()=0
| Invoke solver's built-in enumeration algorithm.
Parameter set/get methods
- The set methods return true if the parameter was set to the given value, false otherwise. When a set method returns false, the original value (if any) should be unchanged. There can be various reasons for failure: the given parameter is not applicable for the solver (e.g., refactorization frequency for the volume algorithm), the parameter is not yet implemented for the solver or simply the value of the parameter is out of the range the solver accepts. If a parameter setting call returns false check the details of your solver. The get methods return true if the given parameter is applicable for the solver and is implemented. In this case the value of the parameter is returned in the second argument. Otherwise they return false. Note: There is a default implementation of the set/get methods, namely to store/retrieve the given value using an array in the base class. A specific solver implementation can use this feature, for example, to store parameters that should be used later on. Implementors of a solver interface should overload these functions to provide the proper interface to and accurately reflect the capabilities of a specific solver. The format for hints is slightly different in that the value is boolean and there is an enum to show strength of hint. There is also an optional void pointer to allow for any eventuality. Hints should be initialised when a solver is instantiated. (See OsiSolverParameters.hpp for defined hint parameters and strength.) A value of true means to work with the hint, false to work against it. For example,
       setHintParam(OsiDoScale,true,OsiHintTry)
- is a mild suggestion to the solver to scale the constraint system.
       setHintParam(OsiDoScale,false,OsiForceDo)
tells the solver to disable scaling, or throw an exception if it cannot comply. As another example, a solver interface could use the value and strength of the `OsiDoReducePrint` hint to adjust the amount of information printed by the interface and/or solver. The extent to which a solver obeys hints is left to the solver. The value and strength returned by `getHintParam` will match the most recent call to `setHintParam`, and will not necessarily reflect the solver's ability to comply with the hint. If the hint strength is `OsiForceDo`, the solver is required to throw an exception if it cannot perform the specified action. Note: As with the other set/get methods, there is a default implementation which maintains arrays in the base class for hint value and strength. The default implementation does not store the void pointer, and always throws an exception for strength `OsiForceDo`. Implementors of a solver interface should overload these functions to provide the proper interface to and accurately reflect the capabilities of a specific solver.
virtual bool | setIntParam (OsiIntParam key, int value)
virtual bool | setDblParam (OsiDblParam key, double value)
virtual bool | setStrParam (OsiStrParam key, const std::string &value)
virtual bool | setHintParam (OsiHintParam key, bool yesNo=true, OsiHintStrength strength=OsiHintTry, void *otherInformation=NULL)
virtual bool | getIntParam (OsiIntParam key, int &value) const
virtual bool | getDblParam (OsiDblParam key, double &value) const
double | getIntegerTolerance () const
| We should be able to get an integer tolerance.
virtual bool | getStrParam (OsiStrParam key, std::string &value) const
virtual bool | getHintParam (OsiHintParam key, bool &yesNo, OsiHintStrength &strength, void *&otherInformation) const
virtual bool | getHintParam (OsiHintParam key, bool &yesNo, OsiHintStrength &strength) const
virtual bool | getHintParam (OsiHintParam key, bool &yesNo) const
void | copyParameters (OsiSolverInterface &rhs)
Methods returning info on how the solution process terminated
virtual bool | isAbandoned () const =0
| Are there numerical difficulties?
virtual bool | isProvenOptimal () const =0
| Is optimality proven?
virtual bool | isProvenPrimalInfeasible () const =0
| Is primal infeasiblity proven?
virtual bool | isProvenDualInfeasible () const =0
| Is dual infeasiblity proven?
virtual bool | isPrimalObjectiveLimitReached () const =0
| Is the given primal objective limit reached?
virtual bool | isDualObjectiveLimitReached () const =0
| Is the given dual objective limit reached?
virtual bool | isIterationLimitReached () const =0
| Iteration limit reached?
Warm start methods
Note that the warm start methods return a generic CoinWarmStart object. The precise characteristics of this object are solver-dependent. Clients who wish to maintain a maximum degree of solver independence should take care to avoid unnecessary assumptions about the properties of a warm start object.
virtual CoinWarmStart * | getEmptyWarmStart () const =0
| Get an empty warm start object.
virtual CoinWarmStart * | getWarmStart () const =0
| Get warm start information.
virtual CoinWarmStart * | getPointerToWarmStart (bool &mustDelete)
| Get warm start information.
virtual bool | setWarmStart (const CoinWarmStart *warmstart)=0
| Set warm start information.
Hot start methods
Primarily used in strong branching. The user can create a hot start object --- a snapshot of the optimization process --- then reoptimize over and over again, starting from the same point. Note: Between hot started optimizations only bound changes are allowed. The copy constructor and assignment operator should NOT copy any hot start information. The default implementation simply extracts a warm start object in `markHotStart`, resets to the warm start object in `solveFromHotStart`, and deletes the warm start object in `unmarkHotStart`. Actual solver implementations are encouraged to do better.
virtual void | markHotStart ()
| Create a hot start snapshot of the optimization process.
virtual void | solveFromHotStart ()
| Optimize starting from the hot start snapshot.
virtual void | unmarkHotStart ()
| Delete the hot start snapshot.
Problem query methods
Querying a problem that has no data associated with it will result in zeros for the number of rows and columns, and NULL pointers from the methods that return vectors. Const pointers returned from any data-query method are valid as long as the data is unchanged and the solver is not called.
virtual int | getNumCols () const =0
| Get number of columns.
virtual int | getNumRows () const =0
| Get number of rows.
virtual int | getNumElements () const =0
| Get number of nonzero elements.
virtual int | getNumIntegers () const
| Get number of integer variables.
virtual const double * | getColLower () const =0
| Get pointer to array[getNumCols()] of column lower bounds.
virtual const double * | getColUpper () const =0
| Get pointer to array[getNumCols()] of column upper bounds.
virtual const char * | getRowSense () const =0
| Get pointer to array[getNumRows()] of row constraint senses.
virtual const double * | getRightHandSide () const =0
| Get pointer to array[getNumRows()] of row right-hand sides.
virtual const double * | getRowRange () const =0
| Get pointer to array[getNumRows()] of row ranges.
virtual const double * | getRowLower () const =0
| Get pointer to array[getNumRows()] of row lower bounds.
virtual const double * | getRowUpper () const =0
| Get pointer to array[getNumRows()] of row upper bounds.
virtual const double * | getObjCoefficients () const =0
| Get pointer to array[getNumCols()] of objective function coefficients.
virtual double | getObjSense () const =0
| Get objective function sense (1 for min (default), -1 for max).
virtual bool | isContinuous (int colIndex) const =0
| Return true if variable is continuous.
virtual bool | isBinary (int colIndex) const
| Return true if variable is binary.
virtual bool | isInteger (int colIndex) const
| Return true if column is integer.
virtual bool | isIntegerNonBinary (int colIndex) const
| Return true if variable is general integer.
virtual bool | isFreeBinary (int colIndex) const
| Return true if variable is binary and not fixed at either bound.
const char * | columnType (bool refresh=false) const
| Return array of column length 0 - continuous 1 - binary (may get fixed to 0 or 1 later) 2 - general integer (may get fixed later) Deprecated usage.
virtual const char * | getColType (bool refresh=false) const
| Return array of column length 0 - continuous 1 - binary (may get fixed to 0 or 1 later) 2 - general integer (may get fixed later).
virtual const CoinPackedMatrix * | getMatrixByRow () const =0
| Get pointer to row-wise copy of matrix.
virtual const CoinPackedMatrix * | getMatrixByCol () const =0
| Get pointer to column-wise copy of matrix.
virtual CoinPackedMatrix * | getMutableMatrixByRow () const
| Get pointer to mutable row-wise copy of matrix (returns NULL if not meaningful).
virtual CoinPackedMatrix * | getMutableMatrixByCol () const
| Get pointer to mutable column-wise copy of matrix (returns NULL if not meaningful).
virtual double | getInfinity () const =0
| Get solver's value for infinity.
Solution query methods
virtual const double * | getColSolution () const =0
| Get pointer to array[getNumCols()] of primal variable values.
const double * | getStrictColSolution ()
| Get pointer to an array[getNumCols()] of primal variable values that are guaranteed to be between the column lower and upper bounds.
virtual const double * | getRowPrice () const =0
| Get pointer to array[getNumRows()] of dual variable values.
virtual const double * | getReducedCost () const =0
| Get a pointer to array[getNumCols()] of reduced costs.
virtual const double * | getRowActivity () const =0
| Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector).
virtual double | getObjValue () const =0
| Get objective function value.
virtual int | getIterationCount () const =0
| Get the number of iterations it took to solve the problem (whatever ``iteration'' means to the solver).
virtual std::vector< double * > | getDualRays (int maxNumRays) const =0
| Get as many dual rays as the solver can provide.
virtual std::vector< double * > | getPrimalRays (int maxNumRays) const =0
| Get as many primal rays as the solver can provide.
virtual OsiVectorInt | getFractionalIndices (const double etol=1.e-05) const
| Get vector of indices of primal variables which are integer variables but have fractional values in the current solution.
Methods to modify the objective, bounds, and solution
For functions which take a set of indices as parameters (`setObjCoeffSet()`, `setColSetBounds()`, `setRowSetBounds()`, `setRowSetTypes()`), the parameters follow the C++ STL iterator convention: `indexFirst` points to the first index in the set, and `indexLast` points to a position one past the last index in the set.
virtual void | setObjCoeff (int elementIndex, double elementValue)=0
| Set an objective function coefficient.
virtual void | setObjCoeffSet (const int *indexFirst, const int *indexLast, const double *coeffList)
| Set a set of objective function coefficients.
virtual void | setObjective (const double *array)
| Set the objective coefficients for all columns.
virtual void | setObjSense (double s)=0
| Set the objective function sense.
virtual void | setColLower (int elementIndex, double elementValue)=0
| Set a single column lower bound.
virtual void | setColLower (const double *array)
| Set the lower bounds for all columns.
virtual void | setColUpper (int elementIndex, double elementValue)=0
| Set a single column upper bound.
virtual void | setColUpper (const double *array)
| Set the upper bounds for all columns.
virtual void | setColBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound.
virtual void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the upper and lower bounds of a set of columns.
virtual void | setRowLower (int elementIndex, double elementValue)=0
| Set a single row lower bound.
virtual void | setRowUpper (int elementIndex, double elementValue)=0
| Set a single row upper bound.
virtual void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound.
virtual void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a set of rows.
virtual void | setRowType (int index, char sense, double rightHandSide, double range)=0
| Set the type of a single row.
virtual void | setRowSetTypes (const int *indexFirst, const int *indexLast, const char *senseList, const double *rhsList, const double *rangeList)
| Set the type of a set of rows.
virtual void | setColSolution (const double *colsol)=0
| Set the primal solution variable values.
virtual void | setRowPrice (const double *rowprice)=0
| Set dual solution variable values.
virtual int | reducedCostFix (double gap, bool justInteger=true)
| Fix variables at bound based on reduced cost.
Methods to set variable type
virtual void | setContinuous (int index)=0
| Set the index-th variable to be a continuous variable.
virtual void | setInteger (int index)=0
| Set the index-th variable to be an integer variable.
virtual void | setContinuous (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be continuous variables.
virtual void | setInteger (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be integer variables.
Methods for row and column names
Osi defines three name management disciplines: `auto names' (0), `lazy names' (1), and `full names' (2). See the description of OsiNameDiscipline for details. Changing the name discipline (via setIntParam()) will not automatically add or remove name information, but setting the discipline to auto will make existing information inaccessible until the discipline is reset to lazy or full. By definition, a row index of getNumRows() (i.e., one larger than the largest valid row index) refers to the objective function. OSI users and implementors: While the OSI base class can define an interface and provide rudimentary support, use of names really depends on support by the OsiXXX class to ensure that names are managed correctly. If an OsiXXX class does not support names, it should return false for calls to getIntParam() or setIntParam() that reference OsiNameDiscipline.
virtual std::string | dfltRowColName (char rc, int ndx, unsigned digits=7) const
| Generate a standard name of the form Rnnnnnnn or Cnnnnnnn.
virtual std::string | getObjName (unsigned maxLen=static_cast< unsigned >(std::string::npos)) const
| Return the name of the objective function.
virtual void | setObjName (std::string name)
| Set the name of the objective function.
virtual std::string | getRowName (int rowIndex, unsigned maxLen=static_cast< unsigned >(std::string::npos)) const
| Return the name of the row.
virtual const OsiNameVec & | getRowNames ()
| Return a pointer to a vector of row names.
virtual void | setRowName (int ndx, std::string name)
| Set a row name.
virtual void | setRowNames (OsiNameVec &srcNames, int srcStart, int len, int tgtStart)
| Set multiple row names.
virtual void | deleteRowNames (int tgtStart, int len)
| Delete len row names starting at index tgtStart.
virtual std::string | getColName (int colIndex, unsigned maxLen=static_cast< unsigned >(std::string::npos)) const
| Return the name of the column.
virtual const OsiNameVec & | getColNames ()
| Return a pointer to a vector of column names.
virtual void | setColName (int ndx, std::string name)
| Set a column name.
virtual void | setColNames (OsiNameVec &srcNames, int srcStart, int len, int tgtStart)
| Set multiple column names.
virtual void | deleteColNames (int tgtStart, int len)
| Delete len column names starting at index tgtStart.
void | setRowColNames (const CoinMpsIO &mps)
| Set row and column names from a CoinMpsIO object.
void | setRowColNames (CoinModel &mod)
| Set row and column names from a CoinModel object.
void | setRowColNames (CoinLpIO &mod)
| Set row and column names from a CoinLpIO object.
Methods to modify the constraint system.
Note that new columns are added as continuous variables.
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj)=0
| Add a column (primal variable) to the problem.
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj, std::string name)
| Add a named column (primal variable) to the problem.
virtual void | addCol (int numberElements, const int *rows, const double *elements, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem.
virtual void | addCol (int numberElements, const int *rows, const double *elements, const double collb, const double colub, const double obj, std::string name)
| Add a named column (primal variable) to the problem.
virtual void | addCols (const int numcols, const CoinPackedVectorBase *const *cols, const double *collb, const double *colub, const double *obj)
| Add a set of columns (primal variables) to the problem.
virtual void | addCols (const int numcols, const int *columnStarts, const int *rows, const double *elements, const double *collb, const double *colub, const double *obj)
| Add a set of columns (primal variables) to the problem.
void | addCols (const CoinBuild &buildObject)
| Add columns using a CoinBuild object.
int | addCols (CoinModel &modelObject)
| Add columns from a model object.
virtual void | deleteCols (const int num, const int *colIndices)=0
| Remove a set of columns (primal variables) from the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub)=0
| Add a row (constraint) to the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub, std::string name)
| Add a named row (constraint) to the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng)=0
| Add a row (constraint) to the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng, std::string name)
| Add a named row (constraint) to the problem.
virtual void | addRow (int numberElements, const int *columns, const double *element, const double rowlb, const double rowub)
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const double *rowlb, const double *rowub)
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const char *rowsen, const double *rowrhs, const double *rowrng)
| Add a set of rows (constraints) to the problem.
virtual void | addRows (const int numrows, const int *rowStarts, const int *columns, const double *element, const double *rowlb, const double *rowub)
| Add a set of rows (constraints) to the problem.
void | addRows (const CoinBuild &buildObject)
| Add rows using a CoinBuild object.
int | addRows (CoinModel &modelObject)
virtual void | deleteRows (const int num, const int *rowIndices)=0
| Delete a set of rows (constraints) from the problem.
virtual void | saveBaseModel ()
| If solver wants it can save a copy of "base" (continuous) model here.
virtual void | restoreBaseModel (int numberRows)
| Strip off rows to get to this number of rows.
virtual ApplyCutsReturnCode | applyCuts (const OsiCuts &cs, double effectivenessLb=0.0)
| Apply a collection of cuts.
virtual void | applyRowCuts (int numberCuts, const OsiRowCut *cuts)
| Apply a collection of row cuts which are all effective.
virtual void | applyRowCuts (int numberCuts, const OsiRowCut **cuts)
| Apply a collection of row cuts which are all effective.
void | deleteBranchingInfo (int numberDeleted, const int *which)
| Deletes branching information before columns deleted.
Methods for problem input and output
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)=0
| Load in a problem by copying the arguments. The constraints on the rows are given by lower and upper bounds.
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, double *&rowlb, double *&rowub)=0
| Load in a problem by assuming ownership of the arguments. The constraints on the rows are given by lower and upper bounds.
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)=0
| Load in a problem by copying the arguments. The constraints on the rows are given by sense/rhs/range triplets.
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, char *&rowsen, double *&rowrhs, double *&rowrng)=0
| Load in a problem by assuming ownership of the arguments. The constraints on the rows are given by sense/rhs/range triplets.
virtual void | loadProblem (const int numcols, const int numrows, const CoinBigIndex *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)=0
| Load in a problem by copying the arguments. The constraint matrix is is specified with standard column-major column starts / row indices / coefficients vectors. The constraints on the rows are given by lower and upper bounds.
virtual void | loadProblem (const int numcols, const int numrows, const CoinBigIndex *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)=0
| Load in a problem by copying the arguments. The constraint matrix is is specified with standard column-major column starts / row indices / coefficients vectors. The constraints on the rows are given by sense/rhs/range triplets.
virtual int | loadFromCoinModel (CoinModel &modelObject, bool keepSolution=false)
| Load a model from a CoinModel object. Return the number of errors encountered.
virtual int | readMps (const char *filename, const char *extension="mps")
| Read a problem in MPS format from the given filename.
virtual int | readMps (const char *filename, const char *extension, int &numberSets, CoinSet **&sets)
| Read a problem in MPS format from the given full filename.
virtual int | readGMPL (const char *filename, const char *dataname=NULL)
| Read a problem in GMPL format from the given filenames.
virtual void | writeMps (const char *filename, const char *extension="mps", double objSense=0.0) const =0
| Write the problem in MPS format to the specified file.
int | writeMpsNative (const char *filename, const char **rowNames, const char **columnNames, int formatType=0, int numberAcross=2, double objSense=0.0, int numberSOS=0, const CoinSet *setInfo=NULL) const
| Write the problem in MPS format to the specified file with more control over the output.
virtual void | writeLp (const char *filename, const char *extension="lp", double epsilon=1e-5, int numberAcross=10, int decimals=5, double objSense=0.0, bool useRowNames=true) const
| Write the problem into an Lp file of the given filename with the specified extension.
virtual void | writeLp (FILE *fp, double epsilon=1e-5, int numberAcross=10, int decimals=5, double objSense=0.0, bool useRowNames=true) const
| Write the problem into the file pointed to by the parameter fp.
int | writeLpNative (const char *filename, char const *const *const rowNames, char const *const *const columnNames, const double epsilon=1.0e-5, const int numberAcross=10, const int decimals=5, const double objSense=0.0, const bool useRowNames=true) const
| Write the problem into an Lp file.
int | writeLpNative (FILE *fp, char const *const *const rowNames, char const *const *const columnNames, const double epsilon=1.0e-5, const int numberAcross=10, const int decimals=5, const double objSense=0.0, const bool useRowNames=true) const
| Write the problem into the file pointed to by the parameter fp.
virtual int | readLp (const char *filename, const double epsilon=1e-5)
| Read file in LP format from file with name filename.
int | readLp (FILE *fp, const double epsilon=1e-5)
| Read file in LP format from the file pointed to by fp.
virtual void | replaceMatrixOptional (const CoinPackedMatrix &matrix)
| I (JJF) am getting annoyed because I can't just replace a matrix.
virtual void | replaceMatrix (const CoinPackedMatrix &matrix)
| And if it does matter (not used at present).
Setting/Accessing application data
void | setApplicationData (void *appData)
| Set application data.
void | setAuxiliaryInfo (OsiAuxInfo *auxiliaryInfo)
| Create a clone of an Auxiliary Information object.
void * | getApplicationData () const
| Get application data.
OsiAuxInfo * | getAuxiliaryInfo () const
| Get pointer to auxiliary info object.
Message handling
See the COIN library documentation for additional information about COIN message facilities.
virtual void | passInMessageHandler (CoinMessageHandler *handler)
| Pass in a message handler.
void | newLanguage (CoinMessages::Language language)
| Set language.
void | setLanguage (CoinMessages::Language language)
| Pass in a message handler.
CoinMessageHandler * | messageHandler () const
| Return a pointer to the current message handler.
CoinMessages | messages ()
| Return the current set of messages.
CoinMessages * | messagesPointer ()
| Return a pointer to the current set of messages.
bool | defaultHandler () const
| Return true if default handler.
Methods for dealing with discontinuities other than integers.
Osi should be able to know about SOS and other types. This is an optional section where such information can be stored.
void | findIntegers (bool justCount)
| Identify integer variables and create corresponding objects.
virtual int | findIntegersAndSOS (bool justCount)
| Identify integer variables and SOS and create corresponding objects.
int | numberObjects () const
| Get the number of objects.
void | setNumberObjects (int number)
| Set the number of objects.
OsiObject ** | objects () const
| Get the array of objects.
const OsiObject * | object (int which) const
| Get the specified object.
OsiObject * | modifiableObject (int which) const
| Get the specified object.
void | deleteObjects ()
| Delete all object information.
void | addObjects (int numberObjects, OsiObject **objects)
| Add in object information.
double | forceFeasible ()
| Use current solution to set bounds so current integer feasible solution will stay feasible.
Methods related to testing generated cuts
virtual void | activateRowCutDebugger (const char *modelName)
| Activate the row cut debugger.
virtual void | activateRowCutDebugger (const double *solution)
| Activate debugger using full solution array.
const OsiRowCutDebugger * | getRowCutDebugger () const
| Get the row cut debugger.
const OsiRowCutDebugger * | getRowCutDebuggerAlways () const
| If you want to get debugger object even if not on optimal path then use this.
OsiSimplexInterface methods
Abstract Base Class for describing an advanced interface to a simplex solver. When switched on allows great control of simplex iterations. Also allows access to tableau.
virtual int | canDoSimplexInterface () const
| Returns 1 if can just do getBInv etc 2 if has all OsiSimplex methods and 0 if it has none.
virtual void | enableSimplexInterface (bool doingPrimal)
| Enables normal operation of subsequent functions.
virtual void | disableSimplexInterface ()
| Undo whatever setting changes the above method had to make.
virtual void | enableFactorization () const
| Tells solver that calls to getBInv etc are about to take place.
virtual void | disableFactorization () const
| and stop
virtual bool | basisIsAvailable () const
| Returns true if a basis is available AND problem is optimal.
bool | optimalBasisIsAvailable () const
| Synonym for basisIsAvailable!
virtual void | getBasisStatus (int *cstat, int *rstat) const
| The following two methods may be replaced by the methods of OsiSolverInterface using OsiWarmStartBasis if: 1.
virtual int | setBasisStatus (const int *cstat, const int *rstat)
| Set the status of structural/artificial variables and factorize, update solution etc.
virtual int | pivot (int colIn, int colOut, int outStatus)
| Perform a pivot by substituting a colIn for colOut in the basis.
virtual int | primalPivotResult (int colIn, int sign, int &colOut, int &outStatus, double &t, CoinPackedVector *dx)
| Obtain a result of the primal pivot Outputs: colOut -- leaving column, outStatus -- its status, t -- step size, and, if dx!=NULL, *dx -- primal ray direction.
virtual int | dualPivotResult (int &colIn, int &sign, int colOut, int outStatus, double &t, CoinPackedVector *dx)
| Obtain a result of the dual pivot (similar to the previous method) Differences: entering variable and a sign of its change are now the outputs, the leaving variable and its statuts -- the inputs If dx!=NULL, then *dx contains dual ray Return code: same.
virtual void | getReducedGradient (double *columnReducedCosts, double *duals, const double *c)
| Get the reduced gradient for the cost vector c.
virtual void | setObjectiveAndRefresh (double *c)
| Set a new objective and apply the old basis so that the reduced costs are properly updated.
virtual void | getBInvARow (int row, double *z, double *slack=NULL) const
| Get a row of the tableau (slack part in slack if not NULL).
virtual void | getBInvRow (int row, double *z) const
| Get a row of the basis inverse.
virtual void | getBInvACol (int col, double *vec) const
| Get a column of the tableau.
virtual void | getBInvCol (int col, double *vec) const
| Get a column of the basis inverse.
virtual void | getBasics (int *index) const
| Get basic indices (order of indices corresponds to the order of elements in a vector retured by getBInvACol() and getBInvCol()).
Constructors and destructors
| OsiSolverInterface ()
| Default Constructor.
virtual OsiSolverInterface * | clone (bool copyData=true) const =0
| Clone.
| OsiSolverInterface (const OsiSolverInterface &)
| Copy constructor.
OsiSolverInterface & | operator= (const OsiSolverInterface &rhs)
| Assignment operator.
virtual | ~OsiSolverInterface ()
| Destructor.
virtual void | reset ()
| Reset the solver interface.
## Protected Member Functions
Protected methods
virtual void | applyRowCut (const OsiRowCut &rc)=0
| Apply a row cut (append to the constraint matrix).
virtual void | applyColCut (const OsiColCut &cc)=0
| Apply a column cut (adjust the bounds of one or more variables).
void | convertBoundToSense (const double lower, const double upper, char &sense, double &right, double &range) const
| A quick inlined function to convert from the lb/ub style of constraint definition to the sense/rhs/range style.
void | convertSenseToBound (const char sense, const double right, const double range, double &lower, double &upper) const
| A quick inlined function to convert from the sense/rhs/range style of constraint definition to the lb/ub style.
template<class T>
T | forceIntoRange (const T value, const T lower, const T upper) const
| A quick inlined function to force a value to be between a minimum and a maximum value.
void | setInitialData ()
| Set OsiSolverInterface object state for default constructor.
## Protected Attributes
Protected member data
OsiRowCutDebugger * | rowCutDebugger_
| Pointer to row cut debugger object.
CoinMessageHandler * | handler_
| Message handler.
bool | defaultHandler_
| Flag to say if the currrent handler is the default handler.
CoinMessages | messages_
| Messages.
int | numberIntegers_
| Number of integers.
int | numberObjects_
| Total number of objects.
OsiObject ** | object_
| Integer and ... information (integer info normally at beginning).
char * | columnType_
| Column type 0 - continuous 1 - binary (may get fixed later) 2 - general integer (may get fixed later).
## Private Attributes
Private member data
OsiAuxInfo * | appDataEtc_
| Pointer to user-defined data structure - and more if user wants.
int | intParam_ [OsiLastIntParam]
| Array of integer parameters.
double | dblParam_ [OsiLastDblParam]
| Array of double parameters.
std::string | strParam_ [OsiLastStrParam]
| Array of string parameters.
bool | hintParam_ [OsiLastHintParam]
| Array of hint parameters.
OsiHintStrength | hintStrength_ [OsiLastHintParam]
| Array of hint strengths.
CoinWarmStart * | ws_
| Warm start information used for hot starts when the default hot start implementation is used.
std::vector< double > | strictColSolution_
| Column solution satisfying lower and upper column bounds.
OsiNameVec | rowNames_
| Row names.
OsiNameVec | colNames_
| Column names.
std::string | objName_
| Objective name.
## Friends
int | OsiSolverInterfaceCommonUnitTest (const OsiSolverInterface *emptySi, const std::string &mpsDir, const std::string &netlibDir)
| A function that tests the methods in the OsiSolverInterface class.
int | OsiSolverInterfaceMpsUnitTest (const std::vector< OsiSolverInterface * > &vecSiP, const std::string &mpsDir)
| A function that tests that a lot of problems given in MPS files (mostly the NETLIB problems) solve properly with all the specified solvers.
## Classes
class | ApplyCutsReturnCode
| Internal class for obtaining status from the applyCuts method. More...

## Detailed Description

Solver Interface Abstract Base Class.

Abstract Base Class for describing an interface to a solver.

Many OsiSolverInterface query methods return a const pointer to the requested read-only data. If the model data is changed or the solver is called, these pointers may no longer be valid and should be refreshed by invoking the member function to obtain an updated copy of the pointer. For example:

          OsiSolverInterface solverInterfacePtr ;
          const double * ruBnds = solverInterfacePtr->getRowUpper();
          solverInterfacePtr->applyCuts(someSetOfCuts);
          // ruBnds is no longer a valid pointer and must be refreshed
          ruBnds = solverInterfacePtr->getRowUpper();

Querying a problem that has no data associated with it will result in zeros for the number of rows and columns, and NULL pointers from the methods that return vectors.

Definition at line 59 of file OsiSolverInterface.hpp.

## Member Typedef Documentation

typedef std::vector<std::string> OsiSolverInterface::OsiNameVec

Data type for name vectors.

Definition at line 789 of file OsiSolverInterface.hpp.

## Constructor & Destructor Documentation

OsiSolverInterface::OsiSolverInterface | ( |  | ) |

Default Constructor.

OsiSolverInterface::OsiSolverInterface | ( | const OsiSolverInterface & |  | ) |

Copy constructor.

virtual OsiSolverInterface::~OsiSolverInterface | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual void OsiSolverInterface::initialSolve | ( |  | ) | `[pure virtual]`

Solve initial LP relaxation.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::resolve | ( |  | ) | `[pure virtual]`

Resolve an LP relaxation after problem modification.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::branchAndBound | ( |  | ) | `[pure virtual]`

Invoke solver's built-in enumeration algorithm.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual bool OsiSolverInterface::setIntParam | ( | OsiIntParam | key,
|  | int | value |
| ) |  |  | `[inline, virtual]`

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Definition at line 249 of file OsiSolverInterface.hpp.

References intParam_, and OsiLastIntParam.

virtual bool OsiSolverInterface::setDblParam | ( | OsiDblParam | key,
|  | double | value |
| ) |  |  | `[inline, virtual]`

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Definition at line 255 of file OsiSolverInterface.hpp.

References dblParam_, and OsiLastDblParam.

Referenced by BlisModel::setCutoff().

virtual bool OsiSolverInterface::setStrParam | ( | OsiStrParam | key,
|  | const std::string & | value |
| ) |  |  | `[inline, virtual]`

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Definition at line 261 of file OsiSolverInterface.hpp.

References OsiLastStrParam, and strParam_.

virtual bool OsiSolverInterface::setHintParam | ( | OsiHintParam | key,
|  | bool | yesNo = `true`,
|  | OsiHintStrength | strength = `OsiHintTry`,
|  | void * | otherInformation = `NULL` |
| ) |  |  | `[inline, virtual]`

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiDylpSolverInterface, and OsiGlpkSolverInterface.

Definition at line 267 of file OsiSolverInterface.hpp.

References hintParam_, hintStrength_, OsiForceDo, and OsiLastHintParam.

virtual bool OsiSolverInterface::getIntParam | ( | OsiIntParam | key,
|  | int & | value |
| ) |  |  | const`[inline, virtual]`

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Definition at line 280 of file OsiSolverInterface.hpp.

References intParam_, and OsiLastIntParam.

virtual bool OsiSolverInterface::getDblParam | ( | OsiDblParam | key,
|  | double & | value |
| ) |  |  | const`[inline, virtual]`

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Definition at line 286 of file OsiSolverInterface.hpp.

References dblParam_, and OsiLastDblParam.

Referenced by AbcModel::getCutoff().

double OsiSolverInterface::getIntegerTolerance | ( |  | ) | const`[inline]`

We should be able to get an integer tolerance.

Until that time just use primal tolerance

Definition at line 294 of file OsiSolverInterface.hpp.

References dblParam_, and OsiPrimalTolerance.

virtual bool OsiSolverInterface::getStrParam | ( | OsiStrParam | key,
|  | std::string & | value |
| ) |  |  | const`[inline, virtual]`

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Definition at line 297 of file OsiSolverInterface.hpp.

References OsiLastStrParam, and strParam_.

virtual bool OsiSolverInterface::getHintParam | ( | OsiHintParam | key,
|  | bool & | yesNo,
|  | OsiHintStrength & | strength,
|  | void *& | otherInformation |
| ) |  |  | const`[inline, virtual]`

Reimplemented in OsiCbcSolverInterface, and OsiDylpSolverInterface.

Definition at line 303 of file OsiSolverInterface.hpp.

References hintParam_, hintStrength_, and OsiLastHintParam.

virtual bool OsiSolverInterface::getHintParam | ( | OsiHintParam | key,
|  | bool & | yesNo,
|  | OsiHintStrength & | strength |
| ) |  |  | const`[inline, virtual]`

Reimplemented in OsiCbcSolverInterface.

Definition at line 314 of file OsiSolverInterface.hpp.

References hintParam_, hintStrength_, and OsiLastHintParam.

virtual bool OsiSolverInterface::getHintParam | ( | OsiHintParam | key,
|  | bool & | yesNo |
| ) |  |  | const`[inline, virtual]`

Definition at line 323 of file OsiSolverInterface.hpp.

References hintParam_, and OsiLastHintParam.

void OsiSolverInterface::copyParameters | ( | OsiSolverInterface & | rhs | ) |

virtual bool OsiSolverInterface::isAbandoned | ( |  | ) | const`[pure virtual]`

Are there numerical difficulties?

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual bool OsiSolverInterface::isProvenOptimal | ( |  | ) | const`[pure virtual]`

Is optimality proven?

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual bool OsiSolverInterface::isProvenPrimalInfeasible | ( |  | ) | const`[pure virtual]`

Is primal infeasiblity proven?

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual bool OsiSolverInterface::isProvenDualInfeasible | ( |  | ) | const`[pure virtual]`

Is dual infeasiblity proven?

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual bool OsiSolverInterface::isPrimalObjectiveLimitReached | ( |  | ) | const`[pure virtual]`

Is the given primal objective limit reached?

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual bool OsiSolverInterface::isDualObjectiveLimitReached | ( |  | ) | const`[pure virtual]`

Is the given dual objective limit reached?

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual bool OsiSolverInterface::isIterationLimitReached | ( |  | ) | const`[pure virtual]`

Iteration limit reached?

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual CoinWarmStart* OsiSolverInterface::getEmptyWarmStart | ( |  | ) | const`[pure virtual]`

Get an empty warm start object.

This routine returns an empty warm start object. Its purpose is to provide a way for a client to acquire a warm start object of the appropriate type for the solver, which can then be resized and modified as desired.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual CoinWarmStart* OsiSolverInterface::getWarmStart | ( |  | ) | const`[pure virtual]`

Get warm start information.

Return warm start information for the current state of the solver interface. If there is no valid warm start information, an empty warm start object wil be returned.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual CoinWarmStart* OsiSolverInterface::getPointerToWarmStart | ( | bool & | mustDelete | ) | `[virtual]`

Get warm start information.

Return warm start information for the current state of the solver interface. If there is no valid warm start information, an empty warm start object wil be returned. This does not necessarily create an object - may just point to one. must Delete set true if user should delete returned object.

Reimplemented in OsiClpSolverInterface.

virtual bool OsiSolverInterface::setWarmStart | ( | const CoinWarmStart * | warmstart | ) | `[pure virtual]`

Set warm start information.

Return true or false depending on whether the warm start information was accepted or not. By definition, a call to setWarmStart with a null parameter should cause the solver interface to refresh its warm start information from the underlying solver.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::markHotStart | ( |  | ) | `[virtual]`

Create a hot start snapshot of the optimization process.

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::solveFromHotStart | ( |  | ) | `[virtual]`

Optimize starting from the hot start snapshot.

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::unmarkHotStart | ( |  | ) | `[virtual]`

Delete the hot start snapshot.

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual int OsiSolverInterface::getNumCols | ( |  | ) | const`[pure virtual]`

Get number of columns.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::AbcModel(), AbcNodeDesc::AbcNodeDesc(), OsiColCut::consistent(), BlisModel::getNumCols(), and AbcModel::getNumCols().

virtual int OsiSolverInterface::getNumRows | ( |  | ) | const`[pure virtual]`

Get number of rows.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcNodeDesc::AbcNodeDesc(), BlisModel::getNumRows(), and AbcModel::getNumRows().

virtual int OsiSolverInterface::getNumElements | ( |  | ) | const`[pure virtual]`

Get number of nonzero elements.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getNumElements().

virtual int OsiSolverInterface::getNumIntegers | ( |  | ) | const`[virtual]`

Get number of integer variables.

Reimplemented in OsiDylpSolverInterface.

virtual const double* OsiSolverInterface::getColLower | ( |  | ) | const`[pure virtual]`

Get pointer to array[getNumCols()] of column lower bounds.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by BlisModel::getColLower(), AbcModel::getColLower(), and OsiColCut::infeasible().

virtual const double* OsiSolverInterface::getColUpper | ( |  | ) | const`[pure virtual]`

Get pointer to array[getNumCols()] of column upper bounds.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by BlisModel::getColUpper(), AbcModel::getColUpper(), and OsiColCut::infeasible().

virtual const char* OsiSolverInterface::getRowSense | ( |  | ) | const`[pure virtual]`

Get pointer to array[getNumRows()] of row constraint senses.

- 'L': <= constraint
- 'E': = constraint
- 'G': >= constraint
- 'R': ranged constraint
- 'N': free constraint

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getRowSense().

virtual const double* OsiSolverInterface::getRightHandSide | ( |  | ) | const`[pure virtual]`

Get pointer to array[getNumRows()] of row right-hand sides.

- if getRowSense()[i] == 'L' then getRightHandSide()[i] == getRowUpper()[i]
- if getRowSense()[i] == 'G' then getRightHandSide()[i] == getRowLower()[i]
- if getRowSense()[i] == 'R' then getRightHandSide()[i] == getRowUpper()[i]
- if getRowSense()[i] == 'N' then getRightHandSide()[i] == 0.0

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getRightHandSide().

virtual const double* OsiSolverInterface::getRowRange | ( |  | ) | const`[pure virtual]`

Get pointer to array[getNumRows()] of row ranges.

- if getRowSense()[i] == 'R' then getRowRange()[i] == getRowUpper()[i] - getRowLower()[i]
- if getRowSense()[i] != 'R' then getRowRange()[i] is 0.0

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getRowRange().

virtual const double* OsiSolverInterface::getRowLower | ( |  | ) | const`[pure virtual]`

Get pointer to array[getNumRows()] of row lower bounds.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getRowLower().

virtual const double* OsiSolverInterface::getRowUpper | ( |  | ) | const`[pure virtual]`

Get pointer to array[getNumRows()] of row upper bounds.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getRowUpper().

virtual const double* OsiSolverInterface::getObjCoefficients | ( |  | ) | const`[pure virtual]`

Get pointer to array[getNumCols()] of objective function coefficients.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getObjCoefficients().

virtual double OsiSolverInterface::getObjSense | ( |  | ) | const`[pure virtual]`

Get objective function sense (1 for min (default), -1 for max).

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getCutoff(), AbcModel::getObjSense(), and BlisModel::setCutoff().

virtual bool OsiSolverInterface::isContinuous | ( | int | colIndex | ) | const`[pure virtual]`

Return true if variable is continuous.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::isContinuous().

virtual bool OsiSolverInterface::isBinary | ( | int | colIndex | ) | const`[virtual]`

Return true if variable is binary.

Reimplemented in OsiClpSolverInterface, OsiDylpSolverInterface, and OsiSymSolverInterface.

Referenced by AbcModel::isBinary().

virtual bool OsiSolverInterface::isInteger | ( | int | colIndex | ) | const`[virtual]`

Return true if column is integer.

Note: This function returns true if the the column is binary or a general integer.

Reimplemented in OsiClpSolverInterface, OsiDylpSolverInterface, and OsiSymSolverInterface.

Referenced by AbcModel::AbcModel(), and AbcModel::isInteger().

virtual bool OsiSolverInterface::isIntegerNonBinary | ( | int | colIndex | ) | const`[virtual]`

Return true if variable is general integer.

Reimplemented in OsiClpSolverInterface, OsiDylpSolverInterface, and OsiSymSolverInterface.

Referenced by AbcModel::isIntegerNonBinary().

virtual bool OsiSolverInterface::isFreeBinary | ( | int | colIndex | ) | const`[virtual]`

Return true if variable is binary and not fixed at either bound.

Reimplemented in OsiClpSolverInterface, and OsiSymSolverInterface.

Referenced by AbcModel::isFreeBinary().

const char* OsiSolverInterface::columnType | ( | bool | refresh = `false` | ) | const`[inline]`

Return array of column length 0 - continuous 1 - binary (may get fixed to 0 or 1 later) 2 - general integer (may get fixed later) Deprecated usage.

Definition at line 528 of file OsiSolverInterface.hpp.

References getColType().

virtual const char* OsiSolverInterface::getColType | ( | bool | refresh = `false` | ) | const`[virtual]`

Return array of column length 0 - continuous 1 - binary (may get fixed to 0 or 1 later) 2 - general integer (may get fixed later).

Reimplemented in OsiClpSolverInterface.

Referenced by columnType().

virtual const CoinPackedMatrix* OsiSolverInterface::getMatrixByRow | ( |  | ) | const`[pure virtual]`

Get pointer to row-wise copy of matrix.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getMatrixByRow().

virtual const CoinPackedMatrix* OsiSolverInterface::getMatrixByCol | ( |  | ) | const`[pure virtual]`

Get pointer to column-wise copy of matrix.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getMatrixByCol().

virtual CoinPackedMatrix* OsiSolverInterface::getMutableMatrixByRow | ( |  | ) | const`[inline, virtual]`

Get pointer to mutable row-wise copy of matrix (returns NULL if not meaningful).

Definition at line 544 of file OsiSolverInterface.hpp.

virtual CoinPackedMatrix* OsiSolverInterface::getMutableMatrixByCol | ( |  | ) | const`[inline, virtual]`

Get pointer to mutable column-wise copy of matrix (returns NULL if not meaningful).

Reimplemented in OsiClpSolverInterface.

Definition at line 547 of file OsiSolverInterface.hpp.

virtual double OsiSolverInterface::getInfinity | ( |  | ) | const`[pure virtual]`

Get solver's value for infinity.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by convertBoundToSense(), convertSenseToBound(), and AbcModel::getInfinity().

virtual const double* OsiSolverInterface::getColSolution | ( |  | ) | const`[pure virtual]`

Get pointer to array[getNumCols()] of primal variable values.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getColSolution(), and BlisModel::getLpSolution().

const double* OsiSolverInterface::getStrictColSolution | ( |  | ) |

Get pointer to an array[getNumCols()] of primal variable values that are guaranteed to be between the column lower and upper bounds.

virtual const double* OsiSolverInterface::getRowPrice | ( |  | ) | const`[pure virtual]`

Get pointer to array[getNumRows()] of dual variable values.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getRowPrice().

virtual const double* OsiSolverInterface::getReducedCost | ( |  | ) | const`[pure virtual]`

Get a pointer to array[getNumCols()] of reduced costs.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getReducedCost().

virtual const double* OsiSolverInterface::getRowActivity | ( |  | ) | const`[pure virtual]`

Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector).

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getRowActivity().

virtual double OsiSolverInterface::getObjValue | ( |  | ) | const`[pure virtual]`

Get objective function value.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getCurrentObjValue(), BlisModel::getLpObjValue(), and OsiVolSolverInterface::getObjValue().

virtual int OsiSolverInterface::getIterationCount | ( |  | ) | const`[pure virtual]`

Get the number of iterations it took to solve the problem (whatever ``iteration'' means to the solver).

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::getIterationCount().

virtual std::vector<double*> OsiSolverInterface::getDualRays | ( | int | maxNumRays | ) | const`[pure virtual]`

Get as many dual rays as the solver can provide.

In case of proven primal infeasibility there should be at least one.

Note:
  Implementors of solver interfaces note that the double pointers in the vector should point to arrays of length getNumRows() and they should be allocated via new[].

  Clients of solver interfaces note that it is the client's responsibility to free the double pointers in the vector using delete[].

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual std::vector<double*> OsiSolverInterface::getPrimalRays | ( | int | maxNumRays | ) | const`[pure virtual]`

Get as many primal rays as the solver can provide.

(In case of proven dual infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumCols() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual OsiVectorInt OsiSolverInterface::getFractionalIndices | ( | const double | etol = `1.e-05` | ) | const`[virtual]`

Get vector of indices of primal variables which are integer variables but have fractional values in the current solution.

virtual void OsiSolverInterface::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[pure virtual]`

Set an objective function coefficient.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::setObjCoeffSet | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | coeffList |
| ) |  |  | `[virtual]`

Set a set of objective function coefficients.

Reimplemented in OsiCpxSolverInterface, and OsiMskSolverInterface.

virtual void OsiSolverInterface::setObjective | ( | const double * | array | ) | `[virtual]`

Set the objective coefficients for all columns.

array [getNumCols()] is an array of values for the objective. This defaults to a series of set operations and is here for speed.

Reimplemented in OsiClpSolverInterface.

virtual void OsiSolverInterface::setObjSense | ( | double | s | ) | `[pure virtual]`

Set the objective function sense.

Use 1 for minimisation (default), -1 for maximisation.

Note:
  Implementors note that objective function sense is a parameter of the OSI, not a property of the problem. Objective sense can be set prior to problem load and should not be affected by loading a new problem.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::setObjSense().

virtual void OsiSolverInterface::setColLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[pure virtual]`

Set a single column lower bound.

Use -getInfinity() for -infinity.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by setColBounds().

virtual void OsiSolverInterface::setColLower | ( | const double * | array | ) | `[virtual]`

Set the lower bounds for all columns.

array [getNumCols()] is an array of values for the lower bounds. This defaults to a series of set operations and is here for speed.

Reimplemented in OsiClpSolverInterface.

virtual void OsiSolverInterface::setColUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[pure virtual]`

Set a single column upper bound.

Use getInfinity() for infinity.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by setColBounds().

virtual void OsiSolverInterface::setColUpper | ( | const double * | array | ) | `[virtual]`

Set the upper bounds for all columns.

array [getNumCols()] is an array of values for the upper bounds. This defaults to a series of set operations and is here for speed.

Reimplemented in OsiClpSolverInterface.

virtual void OsiSolverInterface::setColBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[inline, virtual]`

Set a single column lower and upper bound.

The default implementation just invokes setColLower() and setColUpper()

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiSpxSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Definition at line 679 of file OsiSolverInterface.hpp.

References setColLower(), and setColUpper().

virtual void OsiSolverInterface::setColSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the upper and lower bounds of a set of columns.

The default implementation just invokes setColBounds() over and over again. For each column, boundList must contain both a lower and upper bound, in that order.

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::setRowLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[pure virtual]`

Set a single row lower bound.

Use -getInfinity() for -infinity.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by setRowBounds().

virtual void OsiSolverInterface::setRowUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[pure virtual]`

Set a single row upper bound.

Use getInfinity() for infinity.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by setRowBounds().

virtual void OsiSolverInterface::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[inline, virtual]`

Set a single row lower and upper bound.

The default implementation just invokes setRowLower() and setRowUpper()

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Definition at line 706 of file OsiSolverInterface.hpp.

References setRowLower(), and setRowUpper().

virtual void OsiSolverInterface::setRowSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a set of rows.

The default implementation just invokes setRowBounds() over and over again. For each row, boundList must contain both a lower and upper bound, in that order.

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::setRowType | ( | int | index,
|  | char | sense,
|  | double | rightHandSide,
|  | double | range |
| ) |  |  | `[pure virtual]`

Set the type of a single row.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::setRowSetTypes | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const char * | senseList,
|  | const double * | rhsList,
|  | const double * | rangeList |
| ) |  |  | `[virtual]`

Set the type of a set of rows.

The default implementation just invokes setRowType() over and over again.

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::setColSolution | ( | const double * | colsol | ) | `[pure virtual]`

Set the primal solution variable values.

colsol[getNumCols()] is an array of values for the primal variables. These values are copied to memory owned by the solver interface object or the solver. They will be returned as the result of getColSolution() until changed by another call to setColSolution() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::setRowPrice | ( | const double * | rowprice | ) | `[pure virtual]`

Set dual solution variable values.

rowprice[getNumRows()] is an array of values for the dual variables. These values are copied to memory owned by the solver interface object or the solver. They will be returned as the result of getRowPrice() until changed by another call to setRowPrice() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual int OsiSolverInterface::reducedCostFix | ( | double | gap,
|  | bool | justInteger = `true` |
| ) |  |  | `[virtual]`

Fix variables at bound based on reduced cost.

For variables currently at bound, fix the variable at bound if the reduced cost exceeds the gap. Return the number of variables fixed.

If justInteger is set to false, the routine will also fix continuous variables, but the test still assumes a delta of 1.0.

virtual void OsiSolverInterface::setContinuous | ( | int | index | ) | `[pure virtual]`

Set the index-th variable to be a continuous variable.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::setInteger | ( | int | index | ) | `[pure virtual]`

Set the index-th variable to be an integer variable.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::setContinuous | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be continuous variables.

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::setInteger | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be integer variables.

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual std::string OsiSolverInterface::dfltRowColName | ( | char | rc,
|  | int | ndx,
|  | unsigned | digits = `7` |
| ) |  |  | const`[virtual]`

Generate a standard name of the form Rnnnnnnn or Cnnnnnnn.

Set `rc` to 'r' for a row name, 'c' for a column name. The `nnnnnnn' part is generated from ndx and will contain 7 digits by default, padded with zeros if necessary. As a special case, ndx = getNumRows() is interpreted as a request for the name of the objective function. OBJECTIVE is returned, truncated to digits+1 characters to match the row and column names.

Reimplemented in OsiCbcSolverInterface.

virtual std::string OsiSolverInterface::getObjName | ( | unsigned | maxLen = `static_cast< unsigned >(std::string::npos)` | ) | const`[virtual]`

Return the name of the objective function.

Reimplemented in OsiCbcSolverInterface.

virtual void OsiSolverInterface::setObjName | ( | std::string | name | ) | `[inline, virtual]`

Set the name of the objective function.

Reimplemented in OsiCbcSolverInterface, OsiDylpSolverInterface, and OsiGlpkSolverInterface.

Definition at line 830 of file OsiSolverInterface.hpp.

References objName_.

virtual std::string OsiSolverInterface::getRowName | ( | int | rowIndex,
|  | unsigned | maxLen = `static_cast< unsigned >(std::string::npos)` |
| ) |  |  | const`[virtual]`

Return the name of the row.

The routine will always return some name, regardless of the name discipline or the level of support by an OsiXXX derived class. Use maxLen to limit the length.

Reimplemented in OsiCbcSolverInterface, and OsiClpSolverInterface.

virtual const OsiNameVec& OsiSolverInterface::getRowNames | ( |  | ) | `[virtual]`

Return a pointer to a vector of row names.

If the name discipline (OsiNameDiscipline) is auto, the return value will be a vector of length zero. If the name discipline is lazy, the vector will contain only names supplied by the client and will be no larger than needed to hold those names; entries not supplied will be null strings. In particular, the objective name is not included in the vector for lazy names. If the name discipline is full, the vector will have getNumRows() names, either supplied or generated, plus one additional entry for the objective name.

Reimplemented in OsiCbcSolverInterface.

virtual void OsiSolverInterface::setRowName | ( | int | ndx,
|  | std::string | name |
| ) |  |  | `[virtual]`

Set a row name.

Quietly does nothing if the name discipline (OsiNameDiscipline) is auto. Quietly fails if the row index is invalid.

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiDylpSolverInterface, and OsiGlpkSolverInterface.

virtual void OsiSolverInterface::setRowNames | ( | OsiNameVec & | srcNames,
|  | int | srcStart,
|  | int | len,
|  | int | tgtStart |
| ) |  |  | `[virtual]`

Set multiple row names.

The run of len entries starting at srcNames[srcStart] are installed as row names starting at row index tgtStart. The base class implementation makes repeated calls to setRowName.

virtual void OsiSolverInterface::deleteRowNames | ( | int | tgtStart,
|  | int | len |
| ) |  |  | `[virtual]`

Delete len row names starting at index tgtStart.

The specified row names are removed and the remaining row names are copied down to close the gap.

Reimplemented in OsiCbcSolverInterface.

virtual std::string OsiSolverInterface::getColName | ( | int | colIndex,
|  | unsigned | maxLen = `static_cast< unsigned >(std::string::npos)` |
| ) |  |  | const`[virtual]`

Return the name of the column.

The routine will always return some name, regardless of the name discipline or the level of support by an OsiXXX derived class. Use maxLen to limit the length.

Reimplemented in OsiCbcSolverInterface, and OsiClpSolverInterface.

virtual const OsiNameVec& OsiSolverInterface::getColNames | ( |  | ) | `[virtual]`

Return a pointer to a vector of column names.

If the name discipline (OsiNameDiscipline) is auto, the return value will be a vector of length zero. If the name discipline is lazy, the vector will contain only names supplied by the client and will be no larger than needed to hold those names; entries not supplied will be null strings. If the name discipline is full, the vector will have getNumCols() names, either supplied or generated.

Reimplemented in OsiCbcSolverInterface.

virtual void OsiSolverInterface::setColName | ( | int | ndx,
|  | std::string | name |
| ) |  |  | `[virtual]`

Set a column name.

Quietly does nothing if the name discipline (OsiNameDiscipline) is auto. Quietly fails if the column index is invalid.

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiDylpSolverInterface, and OsiGlpkSolverInterface.

virtual void OsiSolverInterface::setColNames | ( | OsiNameVec & | srcNames,
|  | int | srcStart,
|  | int | len,
|  | int | tgtStart |
| ) |  |  | `[virtual]`

Set multiple column names.

The run of len entries starting at srcNames[srcStart] are installed as column names starting at column index tgtStart. The base class implementation makes repeated calls to setColName.

virtual void OsiSolverInterface::deleteColNames | ( | int | tgtStart,
|  | int | len |
| ) |  |  | `[virtual]`

Delete len column names starting at index tgtStart.

The specified column names are removed and the remaining column names are copied down to close the gap.

Reimplemented in OsiCbcSolverInterface.

void OsiSolverInterface::setRowColNames | ( | const CoinMpsIO & | mps | ) |

Set row and column names from a CoinMpsIO object.

Also sets the name of the objective function. If the name discipline is auto, you get what you asked for. This routine does not use setRowName or setColName.

void OsiSolverInterface::setRowColNames | ( | CoinModel & | mod | ) |

Set row and column names from a CoinModel object.

If the name discipline is auto, you get what you asked for. This routine does not use setRowName or setColName.

void OsiSolverInterface::setRowColNames | ( | CoinLpIO & | mod | ) |

Set row and column names from a CoinLpIO object.

Also sets the name of the objective function. If the name discipline is auto, you get what you asked for. This routine does not use setRowName or setColName.

virtual void OsiSolverInterface::addCol | ( | const CoinPackedVectorBase & | vec,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj |
| ) |  |  | `[pure virtual]`

Add a column (primal variable) to the problem.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::addCol | ( | const CoinPackedVectorBase & | vec,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj,
|  | std::string | name |
| ) |  |  | `[virtual]`

Add a named column (primal variable) to the problem.

The default implementation adds the column, then changes the name. This can surely be made more efficient within an OsiXXX class.

virtual void OsiSolverInterface::addCol | ( | int | numberElements,
|  | const int * | rows,
|  | const double * | elements,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj |
| ) |  |  | `[virtual]`

Add a column (primal variable) to the problem.

Reimplemented in OsiCbcSolverInterface, and OsiClpSolverInterface.

virtual void OsiSolverInterface::addCol | ( | int | numberElements,
|  | const int * | rows,
|  | const double * | elements,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj,
|  | std::string | name |
| ) |  |  | `[virtual]`

Add a named column (primal variable) to the problem.

The default implementation adds the column, then changes the name. This can surely be made more efficient within an OsiXXX class.

virtual void OsiSolverInterface::addCols | ( | const int | numcols,
|  | const CoinPackedVectorBase *const * | cols,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj |
| ) |  |  | `[virtual]`

Add a set of columns (primal variables) to the problem.

The default implementation simply makes repeated calls to addCol().

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::addCols | ( | const int | numcols,
|  | const int * | columnStarts,
|  | const int * | rows,
|  | const double * | elements,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj |
| ) |  |  | `[virtual]`

Add a set of columns (primal variables) to the problem.

The default implementation simply makes repeated calls to addCol().

Reimplemented in OsiClpSolverInterface.

void OsiSolverInterface::addCols | ( | const CoinBuild & | buildObject | ) |

Add columns using a CoinBuild object.

int OsiSolverInterface::addCols | ( | CoinModel & | modelObject | ) |

Add columns from a model object.

returns -1 if object in bad state (i.e. has row information) otherwise number of errors modelObject non const as can be regularized as part of build

virtual void OsiSolverInterface::deleteCols | ( | const int | num,
|  | const int * | colIndices |
| ) |  |  | `[pure virtual]`

Remove a set of columns (primal variables) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted variables are nonbasic.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const double | rowlb,
|  | const double | rowub |
| ) |  |  | `[pure virtual]`

Add a row (constraint) to the problem.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const double | rowlb,
|  | const double | rowub,
|  | std::string | name |
| ) |  |  | `[virtual]`

Add a named row (constraint) to the problem.

The default implementation adds the row, then changes the name. This can surely be made more efficient within an OsiXXX class.

virtual void OsiSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const char | rowsen,
|  | const double | rowrhs,
|  | const double | rowrng |
| ) |  |  | `[pure virtual]`

Add a row (constraint) to the problem.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const char | rowsen,
|  | const double | rowrhs,
|  | const double | rowrng,
|  | std::string | name |
| ) |  |  | `[virtual]`

Add a named row (constraint) to the problem.

The default implementation adds the row, then changes the name. This can surely be made more efficient within an OsiXXX class.

virtual void OsiSolverInterface::addRow | ( | int | numberElements,
|  | const int * | columns,
|  | const double * | element,
|  | const double | rowlb,
|  | const double | rowub |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Converts to addRow(CoinPackedVectorBase&,const double,const double).

Reimplemented in OsiClpSolverInterface.

virtual void OsiSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::addRows | ( | const int | numrows,
|  | const int * | rowStarts,
|  | const int * | columns,
|  | const double * | element,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented in OsiClpSolverInterface.

void OsiSolverInterface::addRows | ( | const CoinBuild & | buildObject | ) |

Add rows using a CoinBuild object.

int OsiSolverInterface::addRows | ( | CoinModel & | modelObject | ) |

Add rows from a CoinModel object.

Returns -1 if the object is in the wrong state (i.e., has column-major information), otherwise the number of errors.

The modelObject is not const as it can be regularized as part of the build.

virtual void OsiSolverInterface::deleteRows | ( | const int | num,
|  | const int * | rowIndices |
| ) |  |  | `[pure virtual]`

Delete a set of rows (constraints) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted rows are loose.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::saveBaseModel | ( |  | ) | `[inline, virtual]`

If solver wants it can save a copy of "base" (continuous) model here.

Reimplemented in OsiClpSolverInterface.

Definition at line 1125 of file OsiSolverInterface.hpp.

virtual void OsiSolverInterface::restoreBaseModel | ( | int | numberRows | ) | `[virtual]`

Strip off rows to get to this number of rows.

If solver wants it can restore a copy of "base" (continuous) model here

Reimplemented in OsiClpSolverInterface.

virtual ApplyCutsReturnCode OsiSolverInterface::applyCuts | ( | const OsiCuts & | cs,
|  | double | effectivenessLb = `0.0` |
| ) |  |  | `[virtual]`

Apply a collection of cuts.

Only cuts which have an `effectiveness >= effectivenessLb` are applied.

- ReturnCode.getNumineffective() -- number of cuts which were not applied because they had an `effectiveness < effectivenessLb`
- ReturnCode.getNuminconsistent() -- number of invalid cuts
- ReturnCode.getNuminconsistentWrtIntegerModel() -- number of cuts that are invalid with respect to this integer model
- ReturnCode.getNuminfeasible() -- number of cuts that would make this integer model infeasible
- ReturnCode.getNumApplied() -- number of integer cuts which were applied to the integer model
- cs.size() == getNumineffective() + getNuminconsistent() + getNuminconsistentWrtIntegerModel() + getNuminfeasible() + getNumApplied()

virtual void OsiSolverInterface::applyRowCuts | ( | int | numberCuts,
|  | const OsiRowCut * | cuts |
| ) |  |  | `[virtual]`

Apply a collection of row cuts which are all effective.

applyCuts seems to do one at a time which seems inefficient. Would be even more efficient to pass an array of pointers.

Reimplemented in OsiCbcSolverInterface, and OsiClpSolverInterface.

virtual void OsiSolverInterface::applyRowCuts | ( | int | numberCuts,
|  | const OsiRowCut ** | cuts |
| ) |  |  | `[virtual]`

Apply a collection of row cuts which are all effective.

This is passed in as an array of pointers.

Reimplemented in OsiCbcSolverInterface, and OsiClpSolverInterface.

void OsiSolverInterface::deleteBranchingInfo | ( | int | numberDeleted,
|  | const int * | which |
| ) |  |  |

Deletes branching information before columns deleted.

virtual void OsiSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[pure virtual]`

Load in a problem by copying the arguments. The constraints on the rows are given by lower and upper bounds.

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

Note that the default values for rowub and rowlb produce the constraint -infty <= ax <= infty. This is probably not what you want.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | double *& | rowlb,
|  | double *& | rowub |
| ) |  |  | `[pure virtual]`

Load in a problem by assuming ownership of the arguments. The constraints on the rows are given by lower and upper bounds.

For default argument values see the matching loadProblem method.

Warning:
  The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[pure virtual]`

Load in a problem by copying the arguments. The constraints on the rows are given by sense/rhs/range triplets.

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `obj`: all variables have 0 objective coefficient
- `rowsen`: all rows are >=
- `rowrhs`: all right hand sides are 0
- `rowrng`: 0 for the ranged rows

Note that the default values for rowsen, rowrhs, and rowrng produce the constraint ax >= 0.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | char *& | rowsen,
|  | double *& | rowrhs,
|  | double *& | rowrng |
| ) |  |  | `[pure virtual]`

Load in a problem by assuming ownership of the arguments. The constraints on the rows are given by sense/rhs/range triplets.

For default argument values see the matching loadProblem method.

Warning:
  The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const CoinBigIndex * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[pure virtual]`

Load in a problem by copying the arguments. The constraint matrix is is specified with standard column-major column starts / row indices / coefficients vectors. The constraints on the rows are given by lower and upper bounds.

The matrix vectors must be gap-free. Note that `start` must have `numcols+1` entries so that the length of the last column can be calculated as `start[numcols]-start[numcols-1]`.

See the previous loadProblem method using rowlb and rowub for default argument values.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const CoinBigIndex * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[pure virtual]`

Load in a problem by copying the arguments. The constraint matrix is is specified with standard column-major column starts / row indices / coefficients vectors. The constraints on the rows are given by sense/rhs/range triplets.

The matrix vectors must be gap-free. Note that `start` must have `numcols+1` entries so that the length of the last column can be calculated as `start[numcols]-start[numcols-1]`.

See the previous loadProblem method using sense/rhs/range for default argument values.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual int OsiSolverInterface::loadFromCoinModel | ( | CoinModel & | modelObject,
|  | bool | keepSolution = `false` |
| ) |  |  | `[virtual]`

Load a model from a CoinModel object. Return the number of errors encountered.

The modelObject parameter cannot be const as it may be changed as part of process. If keepSolution is true will try and keep warmStart.

Reimplemented in OsiClpSolverInterface.

virtual int OsiSolverInterface::readMps | ( | const char * | filename,
|  | const char * | extension = `"mps"` |
| ) |  |  | `[virtual]`

Read a problem in MPS format from the given filename.

The default implementation uses CoinMpsIO::readMps() to read the MPS file and returns the number of errors encountered.

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::readInstance().

virtual int OsiSolverInterface::readMps | ( | const char * | filename,
|  | const char * | extension,
|  | int & | numberSets,
|  | CoinSet **& | sets |
| ) |  |  | `[virtual]`

Read a problem in MPS format from the given full filename.

This uses CoinMpsIO::readMps() to read the MPS file and returns the number of errors encountered. It also may return an array of set information

Reimplemented in OsiDylpSolverInterface.

virtual int OsiSolverInterface::readGMPL | ( | const char * | filename,
|  | const char * | dataname = `NULL` |
| ) |  |  | `[virtual]`

Read a problem in GMPL format from the given filenames.

The default implementation uses CoinMpsIO::readGMPL(). This capability is available only if the third-party package Glpk is installed.

Reimplemented in OsiSymSolverInterface.

virtual void OsiSolverInterface::writeMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`,
|  | double | objSense = `0.0` |
| ) |  |  | const`[pure virtual]`

Write the problem in MPS format to the specified file.

If objSense is non-zero, a value of -1.0 causes the problem to be written with a maximization objective; +1.0 forces a minimization objective. If objSense is zero, the choice is left to the implementation.

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

int OsiSolverInterface::writeMpsNative | ( | const char * | filename,
|  | const char ** | rowNames,
|  | const char ** | columnNames,
|  | int | formatType = `0`,
|  | int | numberAcross = `2`,
|  | double | objSense = `0.0`,
|  | int | numberSOS = `0`,
|  | const CoinSet * | setInfo = `NULL` |
| ) |  |  | const

Write the problem in MPS format to the specified file with more control over the output.

Row and column names may be null. formatType is

- 0 - normal
- 1 - extra accuracy
- 2 - IEEE hex

Returns non-zero on I/O error

virtual void OsiSolverInterface::writeLp | ( | const char * | filename,
|  | const char * | extension = `"lp"`,
|  | double | epsilon = `1e-5`,
|  | int | numberAcross = `10`,
|  | int | decimals = `5`,
|  | double | objSense = `0.0`,
|  | bool | useRowNames = `true` |
| ) |  |  | const`[virtual]`

Write the problem into an Lp file of the given filename with the specified extension.

Coefficients with value less than epsilon away from an integer value are written as integers. Write at most numberAcross monomials on a line. Write non integer numbers with decimals digits after the decimal point.

The written problem is always a minimization problem. If the current problem is a maximization problem, the intended objective function for the written problem is the current objective function multiplied by -1. If the current problem is a minimization problem, the intended objective function for the written problem is the current objective function. If objSense < 0, the intended objective function is multiplied by -1 before writing the problem. It is left unchanged otherwise.

Write objective function name and constraint names if useRowNames is true. This version calls writeLpNative().

Reimplemented in OsiClpSolverInterface.

virtual void OsiSolverInterface::writeLp | ( | FILE * | fp,
|  | double | epsilon = `1e-5`,
|  | int | numberAcross = `10`,
|  | int | decimals = `5`,
|  | double | objSense = `0.0`,
|  | bool | useRowNames = `true` |
| ) |  |  | const`[virtual]`

Write the problem into the file pointed to by the parameter fp.

Other parameters are similar to those of writeLp() with first parameter filename.

Reimplemented in OsiClpSolverInterface.

int OsiSolverInterface::writeLpNative | ( | const char * | filename,
|  | char const *const *const | rowNames,
|  | char const *const *const | columnNames,
|  | const double | epsilon = `1.0e-5`,
|  | const int | numberAcross = `10`,
|  | const int | decimals = `5`,
|  | const double | objSense = `0.0`,
|  | const bool | useRowNames = `true` |
| ) |  |  | const

Write the problem into an Lp file.

Parameters are similar to those of writeLp(), but in addition row names and column names may be given.

Parameter rowNames may be NULL, in which case default row names are used. If rowNames is not NULL, it must have exactly one entry per row in the problem and one additional entry (rowNames[getNumRows()] with the objective function name. These getNumRows()+1 entries must be distinct. If this is not the case, default row names are used. In addition, format restrictions are imposed on names (see CoinLpIO::is_invalid_name() for details).

Similar remarks can be made for the parameter columnNames which must either be NULL or have exactly getNumCols() distinct entries.

Write objective function name and constraint names if useRowNames is true.

int OsiSolverInterface::writeLpNative | ( | FILE * | fp,
|  | char const *const *const | rowNames,
|  | char const *const *const | columnNames,
|  | const double | epsilon = `1.0e-5`,
|  | const int | numberAcross = `10`,
|  | const int | decimals = `5`,
|  | const double | objSense = `0.0`,
|  | const bool | useRowNames = `true` |
| ) |  |  | const

Write the problem into the file pointed to by the parameter fp.

Other parameters are similar to those of writeLpNative() with first parameter filename.

virtual int OsiSolverInterface::readLp | ( | const char * | filename,
|  | const double | epsilon = `1e-5` |
| ) |  |  | `[virtual]`

Read file in LP format from file with name filename.

See class CoinLpIO for description of this format.

Reimplemented in OsiClpSolverInterface.

int OsiSolverInterface::readLp | ( | FILE * | fp,
|  | const double | epsilon = `1e-5` |
| ) |  |  |

Read file in LP format from the file pointed to by fp.

See class CoinLpIO for description of this format.

virtual void OsiSolverInterface::replaceMatrixOptional | ( | const CoinPackedMatrix & | matrix | ) | `[inline, virtual]`

I (JJF) am getting annoyed because I can't just replace a matrix.

The default behavior of this is do nothing so only use where that would not matter e.g. strengthening a matrix for MIP

Reimplemented in OsiClpSolverInterface.

Definition at line 1440 of file OsiSolverInterface.hpp.

virtual void OsiSolverInterface::replaceMatrix | ( | const CoinPackedMatrix & | matrix | ) | `[inline, virtual]`

And if it does matter (not used at present).

Reimplemented in OsiClpSolverInterface.

Definition at line 1442 of file OsiSolverInterface.hpp.

void OsiSolverInterface::setApplicationData | ( | void * | appData | ) |

Set application data.

This is a pointer that the application can store into and retrieve from the solver interface. This field is available for the application to optionally define and use.

void OsiSolverInterface::setAuxiliaryInfo | ( | OsiAuxInfo * | auxiliaryInfo | ) |

Create a clone of an Auxiliary Information object.

The base class just stores an application data pointer but can be more general. Application data pointer is designed for one user while this can be extended to cope with more general extensions.

void* OsiSolverInterface::getApplicationData | ( |  | ) | const

Get application data.

OsiAuxInfo* OsiSolverInterface::getAuxiliaryInfo | ( |  | ) | const

Get pointer to auxiliary info object.

virtual void OsiSolverInterface::passInMessageHandler | ( | CoinMessageHandler * | handler | ) | `[virtual]`

Pass in a message handler.

It is the client's responsibility to destroy a message handler installed by this routine; it will not be destroyed when the solver interface is destroyed.

Reimplemented in OsiClpSolverInterface.

void OsiSolverInterface::newLanguage | ( | CoinMessages::Language | language | ) |

Set language.

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, and OsiDylpSolverInterface.

Referenced by setLanguage().

void OsiSolverInterface::setLanguage | ( | CoinMessages::Language | language | ) | `[inline]`

Pass in a message handler.

It is the client's responsibility to destroy a message handler installed by this routine; it will not be destroyed when the solver interface is destroyed.

Reimplemented in OsiCbcSolverInterface, OsiClpSolverInterface, and OsiDylpSolverInterface.

Definition at line 1504 of file OsiSolverInterface.hpp.

References newLanguage().

CoinMessageHandler* OsiSolverInterface::messageHandler | ( |  | ) | const`[inline]`

Return a pointer to the current message handler.

Definition at line 1507 of file OsiSolverInterface.hpp.

References handler_.

CoinMessages OsiSolverInterface::messages | ( |  | ) | `[inline]`

Return the current set of messages.

Definition at line 1510 of file OsiSolverInterface.hpp.

References messages_.

CoinMessages* OsiSolverInterface::messagesPointer | ( |  | ) | `[inline]`

Return a pointer to the current set of messages.

Definition at line 1513 of file OsiSolverInterface.hpp.

References messages_.

bool OsiSolverInterface::defaultHandler | ( |  | ) | const`[inline]`

Return true if default handler.

Definition at line 1516 of file OsiSolverInterface.hpp.

References defaultHandler_.

void OsiSolverInterface::findIntegers | ( | bool | justCount | ) |

Identify integer variables and create corresponding objects.

Record integer variables and create an OsiSimpleInteger object for each one. All existing OsiSimpleInteger objects will be destroyed. If justCount then no objects created and we just store numberIntegers_

virtual int OsiSolverInterface::findIntegersAndSOS | ( | bool | justCount | ) | `[virtual]`

Identify integer variables and SOS and create corresponding objects.

Record integer variables and create an OsiSimpleInteger object for each one. All existing OsiSimpleInteger objects will be destroyed. If the solver supports SOS then do the same for SOS.

If justCount then no objects created and we just store numberIntegers_ Returns number of SOS

Reimplemented in OsiClpSolverInterface.

int OsiSolverInterface::numberObjects | ( |  | ) | const`[inline]`

Get the number of objects.

Definition at line 1547 of file OsiSolverInterface.hpp.

References numberObjects_.

void OsiSolverInterface::setNumberObjects | ( | int | number | ) | `[inline]`

Set the number of objects.

Definition at line 1549 of file OsiSolverInterface.hpp.

References numberObjects_.

OsiObject** OsiSolverInterface::objects | ( |  | ) | const`[inline]`

Get the array of objects.

Definition at line 1553 of file OsiSolverInterface.hpp.

References object_.

const OsiObject* OsiSolverInterface::object | ( | int | which | ) | const`[inline]`

Get the specified object.

Definition at line 1556 of file OsiSolverInterface.hpp.

References object_.

OsiObject* OsiSolverInterface::modifiableObject | ( | int | which | ) | const`[inline]`

Get the specified object.

Definition at line 1558 of file OsiSolverInterface.hpp.

References object_.

void OsiSolverInterface::deleteObjects | ( |  | ) |

Delete all object information.

void OsiSolverInterface::addObjects | ( | int | numberObjects,
|  | OsiObject ** | objects |
| ) |  |  |

Add in object information.

Objects are cloned; the owner can delete the originals.

double OsiSolverInterface::forceFeasible | ( |  | ) |

Use current solution to set bounds so current integer feasible solution will stay feasible.

Only feasible bounds will be used, even if current solution outside bounds. The amount of such violation will be returned (and if small can be ignored)

virtual void OsiSolverInterface::activateRowCutDebugger | ( | const char * | modelName | ) | `[virtual]`

Activate the row cut debugger.

If the model name passed is on list of known models then all cuts are checked to see that they do NOT cut off the known optimal solution.

Reimplemented in OsiDylpSolverInterface.

virtual void OsiSolverInterface::activateRowCutDebugger | ( | const double * | solution | ) | `[virtual]`

Activate debugger using full solution array.

Only integer values need to be correct. Up to user to get it correct. Sets up debugger if solution was valid.

Reimplemented in OsiDylpSolverInterface.

const OsiRowCutDebugger* OsiSolverInterface::getRowCutDebugger | ( |  | ) | const

Get the row cut debugger.

If there is a row cut debugger object associated with model AND if the known optimal solution is within the current feasible region then a pointer to the object is returned which may be used to test validity of cuts.

Otherwise NULL is returned

const OsiRowCutDebugger* OsiSolverInterface::getRowCutDebuggerAlways | ( |  | ) | const

If you want to get debugger object even if not on optimal path then use this.

virtual int OsiSolverInterface::canDoSimplexInterface | ( |  | ) | const`[virtual]`

Returns 1 if can just do getBInv etc 2 if has all OsiSimplex methods and 0 if it has none.

Reimplemented in OsiClpSolverInterface, and OsiCpxSolverInterface.

virtual void OsiSolverInterface::enableSimplexInterface | ( | bool | doingPrimal | ) | `[virtual]`

Enables normal operation of subsequent functions.

This method is supposed to ensure that all typical things (like reduced costs, etc.) are updated when individual pivots are executed and can be queried by other methods. says whether will be doing primal or dual

Reimplemented in OsiClpSolverInterface.

virtual void OsiSolverInterface::disableSimplexInterface | ( |  | ) | `[virtual]`

Undo whatever setting changes the above method had to make.

Reimplemented in OsiClpSolverInterface, and OsiCpxSolverInterface.

virtual void OsiSolverInterface::enableFactorization | ( |  | ) | const`[virtual]`

Tells solver that calls to getBInv etc are about to take place.

Underlying code may need mutable as this may be called from CglCut:;generateCuts which is const. If that is too horrific then each solver e.g. BCP or CBC will have to do something outside main loop.

Reimplemented in OsiClpSolverInterface, and OsiCpxSolverInterface.

virtual void OsiSolverInterface::disableFactorization | ( |  | ) | const`[virtual]`

and stop

Reimplemented in OsiClpSolverInterface, and OsiCpxSolverInterface.

virtual bool OsiSolverInterface::basisIsAvailable | ( |  | ) | const`[virtual]`

Returns true if a basis is available AND problem is optimal.

This should be used to see if the BInvARow type operations are possible and meaningful.

Reimplemented in OsiClpSolverInterface, OsiCpxSolverInterface, and OsiOslSolverInterface.

Referenced by optimalBasisIsAvailable().

bool OsiSolverInterface::optimalBasisIsAvailable | ( |  | ) | const`[inline]`

Synonym for basisIsAvailable!

Definition at line 1649 of file OsiSolverInterface.hpp.

References basisIsAvailable().

virtual void OsiSolverInterface::getBasisStatus | ( | int * | cstat,
|  | int * | rstat |
| ) |  |  | const`[virtual]`

The following two methods may be replaced by the methods of OsiSolverInterface using OsiWarmStartBasis if: 1.

OsiWarmStartBasis resize operation is implemented more efficiently and 2. It is ensured that effects on the solver are the same

Returns a basis status of the structural/artificial variables At present as warm start i.e 0 free, 1 basic, 2 upper, 3 lower

NOTE artificials are treated as +1 elements so for <= rhs artificial will be at lower bound if constraint is tight

Reimplemented in OsiClpSolverInterface, and OsiCpxSolverInterface.

virtual int OsiSolverInterface::setBasisStatus | ( | const int * | cstat,
|  | const int * | rstat |
| ) |  |  | `[virtual]`

Set the status of structural/artificial variables and factorize, update solution etc.

NOTE artificials are treated as +1 elements so for <= rhs artificial will be at lower bound if constraint is tight

Reimplemented in OsiClpSolverInterface.

virtual int OsiSolverInterface::pivot | ( | int | colIn,
|  | int | colOut,
|  | int | outStatus |
| ) |  |  | `[virtual]`

Perform a pivot by substituting a colIn for colOut in the basis.

The status of the leaving variable is given in outStatus. Where 1 is to upper bound, -1 to lower bound Return code was undefined - now for OsiClp is 0 for okay, 1 if inaccuracy forced re-factorization (should be okay) and -1 for singular factorization

Reimplemented in OsiClpSolverInterface.

virtual int OsiSolverInterface::primalPivotResult | ( | int | colIn,
|  | int | sign,
|  | int & | colOut,
|  | int & | outStatus,
|  | double & | t,
|  | CoinPackedVector * | dx |
| ) |  |  | `[virtual]`

Obtain a result of the primal pivot Outputs: colOut -- leaving column, outStatus -- its status, t -- step size, and, if dx!=NULL, *dx -- primal ray direction.

Inputs: colIn -- entering column, sign -- direction of its change (+/-1). Both for colIn and colOut, artificial variables are index by the negative of the row index minus 1. Return code (for now): 0 -- leaving variable found, -1 -- everything else? Clearly, more informative set of return values is required Primal and dual solutions are updated

Reimplemented in OsiClpSolverInterface.

virtual int OsiSolverInterface::dualPivotResult | ( | int & | colIn,
|  | int & | sign,
|  | int | colOut,
|  | int | outStatus,
|  | double & | t,
|  | CoinPackedVector * | dx |
| ) |  |  | `[virtual]`

Obtain a result of the dual pivot (similar to the previous method) Differences: entering variable and a sign of its change are now the outputs, the leaving variable and its statuts -- the inputs If dx!=NULL, then *dx contains dual ray Return code: same.

Reimplemented in OsiClpSolverInterface.

virtual void OsiSolverInterface::getReducedGradient | ( | double * | columnReducedCosts,
|  | double * | duals,
|  | const double * | c |
| ) |  |  | `[virtual]`

Get the reduced gradient for the cost vector c.

Reimplemented in OsiClpSolverInterface.

virtual void OsiSolverInterface::setObjectiveAndRefresh | ( | double * | c | ) | `[virtual]`

Set a new objective and apply the old basis so that the reduced costs are properly updated.

Reimplemented in OsiClpSolverInterface.

virtual void OsiSolverInterface::getBInvARow | ( | int | row,
|  | double * | z,
|  | double * | slack = `NULL` |
| ) |  |  | const`[virtual]`

Get a row of the tableau (slack part in slack if not NULL).

Reimplemented in OsiClpSolverInterface, and OsiCpxSolverInterface.

virtual void OsiSolverInterface::getBInvRow | ( | int | row,
|  | double * | z |
| ) |  |  | const`[virtual]`

Get a row of the basis inverse.

Reimplemented in OsiClpSolverInterface, and OsiCpxSolverInterface.

virtual void OsiSolverInterface::getBInvACol | ( | int | col,
|  | double * | vec |
| ) |  |  | const`[virtual]`

Get a column of the tableau.

Reimplemented in OsiClpSolverInterface, and OsiCpxSolverInterface.

virtual void OsiSolverInterface::getBInvCol | ( | int | col,
|  | double * | vec |
| ) |  |  | const`[virtual]`

Get a column of the basis inverse.

Reimplemented in OsiClpSolverInterface, and OsiCpxSolverInterface.

virtual void OsiSolverInterface::getBasics | ( | int * | index | ) | const`[virtual]`

Get basic indices (order of indices corresponds to the order of elements in a vector retured by getBInvACol() and getBInvCol()).

Reimplemented in OsiClpSolverInterface, and OsiCpxSolverInterface.

virtual OsiSolverInterface* OsiSolverInterface::clone | ( | bool | copyData = `true` | ) | const`[pure virtual]`

Clone.

The result of calling clone(false) is defined to be equivalent to calling the default constructor OsiSolverInterface().

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

Referenced by AbcModel::AbcModel().

OsiSolverInterface& OsiSolverInterface::operator= | ( | const OsiSolverInterface & | rhs | ) |

Assignment operator.

virtual void OsiSolverInterface::reset | ( |  | ) | `[virtual]`

Reset the solver interface.

A call to reset() returns the solver interface to the same state as it would have if it had just been constructed by calling the default constructor OsiSolverInterface().

Reimplemented in OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiOslSolverInterface, and OsiSymSolverInterface.

virtual void OsiSolverInterface::applyRowCut | ( | const OsiRowCut & | rc | ) | `[protected, pure virtual]`

Apply a row cut (append to the constraint matrix).

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

virtual void OsiSolverInterface::applyColCut | ( | const OsiColCut & | cc | ) | `[protected, pure virtual]`

Apply a column cut (adjust the bounds of one or more variables).

Implemented in OsiCbcSolverInterface, OsiClpSolverInterface, OsiCpxSolverInterface, OsiDylpSolverInterface, OsiFmpSolverInterface, OsiGlpkSolverInterface, OsiMskSolverInterface, OsiOslSolverInterface, OsiSpxSolverInterface, OsiSymSolverInterface, OsiVolSolverInterface, and OsiXprSolverInterface.

void OsiSolverInterface::convertBoundToSense | ( | const double | lower,
|  | const double | upper,
|  | char & | sense,
|  | double & | right,
|  | double & | range |
| ) |  |  | const`[inline, protected]`

A quick inlined function to convert from the lb/ub style of constraint definition to the sense/rhs/range style.

Definition at line 1895 of file OsiSolverInterface.hpp.

References getInfinity().

Referenced by OsiVolSolverInterface::setRowBounds(), OsiVolSolverInterface::setRowLower(), and OsiVolSolverInterface::setRowUpper().

void OsiSolverInterface::convertSenseToBound | ( | const char | sense,
|  | const double | right,
|  | const double | range,
|  | double & | lower,
|  | double & | upper |
| ) |  |  | const`[inline, protected]`

A quick inlined function to convert from the sense/rhs/range style of constraint definition to the lb/ub style.

Definition at line 1929 of file OsiSolverInterface.hpp.

References getInfinity().

Referenced by OsiVolSolverInterface::setRowType().

template<class T>

T OsiSolverInterface::forceIntoRange | ( | const T | value,
|  | const T | lower,
|  | const T | upper |
| ) |  |  | const`[inline, protected]`

A quick inlined function to force a value to be between a minimum and a maximum value.

Definition at line 1793 of file OsiSolverInterface.hpp.

void OsiSolverInterface::setInitialData | ( |  | ) | `[protected]`

Set OsiSolverInterface object state for default constructor.

This routine establishes the initial values of data fields in the OsiSolverInterface object when the object is created using the default constructor.

Reimplemented in OsiSymSolverInterface.

## Friends And Related Function Documentation

int OsiSolverInterfaceCommonUnitTest | ( | const OsiSolverInterface * | emptySi,
|  | const std::string & | mpsDir,
|  | const std::string & | netlibDir |
| ) |  |  | `[friend]`

A function that tests the methods in the OsiSolverInterface class.

The only reason for it not to be a member method is that this way it doesn't have to be compiled into the library. And that's a gain, because the library should be compiled with optimization on, but this method should be compiled with debugging. Also, if this method is compiled with optimization, the compilation takes 10-15 minutes and the machine pages (has 256M core memory!)...

int OsiSolverInterfaceMpsUnitTest | ( | const std::vector< OsiSolverInterface * > & | vecSiP,
|  | const std::string & | mpsDir |
| ) |  |  | `[friend]`

A function that tests that a lot of problems given in MPS files (mostly the NETLIB problems) solve properly with all the specified solvers.

## Member Data Documentation

OsiRowCutDebugger* OsiSolverInterface::rowCutDebugger_`[protected]`

Pointer to row cut debugger object.

Definition at line 1808 of file OsiSolverInterface.hpp.

CoinMessageHandler* OsiSolverInterface::handler_`[protected]`

Message handler.

Definition at line 1811 of file OsiSolverInterface.hpp.

Referenced by messageHandler().

bool OsiSolverInterface::defaultHandler_`[protected]`

Flag to say if the currrent handler is the default handler.

Indicates if the solver interface object is responsible for destruction of the handler (true) or if the client is responsible (false).

Definition at line 1817 of file OsiSolverInterface.hpp.

Referenced by defaultHandler().

CoinMessages OsiSolverInterface::messages_`[protected]`

Messages.

Definition at line 1819 of file OsiSolverInterface.hpp.

Referenced by messages(), and messagesPointer().

int OsiSolverInterface::numberIntegers_`[protected]`

Number of integers.

Definition at line 1821 of file OsiSolverInterface.hpp.

int OsiSolverInterface::numberObjects_`[protected]`

Total number of objects.

Definition at line 1823 of file OsiSolverInterface.hpp.

Referenced by numberObjects(), and setNumberObjects().

OsiObject** OsiSolverInterface::object_`[protected]`

Integer and ... information (integer info normally at beginning).

Definition at line 1826 of file OsiSolverInterface.hpp.

Referenced by modifiableObject(), object(), and objects().

char* OsiSolverInterface::columnType_`[mutable, protected]`

Column type 0 - continuous 1 - binary (may get fixed later) 2 - general integer (may get fixed later).

Definition at line 1832 of file OsiSolverInterface.hpp.

OsiAuxInfo* OsiSolverInterface::appDataEtc_`[private]`

Pointer to user-defined data structure - and more if user wants.

Definition at line 1842 of file OsiSolverInterface.hpp.

int OsiSolverInterface::intParam_[OsiLastIntParam]`[private]`

Array of integer parameters.

Definition at line 1844 of file OsiSolverInterface.hpp.

Referenced by getIntParam(), and setIntParam().

double OsiSolverInterface::dblParam_[OsiLastDblParam]`[private]`

Array of double parameters.

Definition at line 1846 of file OsiSolverInterface.hpp.

Referenced by getDblParam(), getIntegerTolerance(), and setDblParam().

std::string OsiSolverInterface::strParam_[OsiLastStrParam]`[private]`

Array of string parameters.

Definition at line 1848 of file OsiSolverInterface.hpp.

Referenced by getStrParam(), and setStrParam().

bool OsiSolverInterface::hintParam_[OsiLastHintParam]`[private]`

Array of hint parameters.

Definition at line 1850 of file OsiSolverInterface.hpp.

Referenced by getHintParam(), and setHintParam().

OsiHintStrength OsiSolverInterface::hintStrength_[OsiLastHintParam]`[private]`

Array of hint strengths.

Definition at line 1852 of file OsiSolverInterface.hpp.

Referenced by getHintParam(), and setHintParam().

CoinWarmStart* OsiSolverInterface::ws_`[private]`

Warm start information used for hot starts when the default hot start implementation is used.

Reimplemented in OsiClpSolverInterface, OsiFmpSolverInterface, and OsiOslSolverInterface.

Definition at line 1855 of file OsiSolverInterface.hpp.

std::vector<double> OsiSolverInterface::strictColSolution_`[private]`

Column solution satisfying lower and upper column bounds.

Definition at line 1857 of file OsiSolverInterface.hpp.

OsiNameVec OsiSolverInterface::rowNames_`[private]`

Row names.

Definition at line 1860 of file OsiSolverInterface.hpp.

OsiNameVec OsiSolverInterface::colNames_`[private]`

Column names.

Definition at line 1862 of file OsiSolverInterface.hpp.

std::string OsiSolverInterface::objName_`[private]`

Objective name.

Definition at line 1864 of file OsiSolverInterface.hpp.

Referenced by setObjName().

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Bcps-0.91.0/Osi/src/OsiSolverInterface.hpp